]> git.proxmox.com Git - ovs.git/blob - debian/openvswitch-switch.init
Debian: Add Joe Perches to debian/copyright
[ovs.git] / debian / openvswitch-switch.init
1 #! /bin/sh
2 #
3 # /etc/init.d/openvswitch-switch
4 #
5 # Written by Miquel van Smoorenburg <miquels@cistron.nl>.
6 # Modified for Debian by Ian Murdock <imurdock@gnu.ai.mit.edu>.
7 # Further changes by Javier Fernandez-Sanguino <jfs@debian.org>
8 # Modified for openvswitch-switch.
9 #
10 # Version: @(#)skeleton 1.9 26-Feb-2001 miquels@cistron.nl
11 #
12 ### BEGIN INIT INFO
13 # Provides: openvswitch-switch
14 # Required-Start: $network $named $remote_fs $syslog
15 # Required-Stop: $remote_fs
16 # Default-Start: 2 3 4 5
17 # Default-Stop: 0 1 6
18 # Short-Description: Open vSwitch switch
19 ### END INIT INFO
20
21 PATH=/usr/local/sbin:/usr/local/bin:/sbin:/bin:/usr/sbin:/usr/bin
22 ovs_vswitchd=/usr/sbin/ovs-vswitchd
23 ovsdb_server=/usr/bin/ovsdb-server
24
25 (test -x $ovsdb_server && test -x $ovs_vswitchd) || exit 0
26
27 DODTIME=1 # Time to wait for the server to die, in seconds
28 # If this value is set too low you might not
29 # let some servers to die gracefully and
30 # 'restart' will not work
31
32 # Include ovs-openflowd defaults if available
33 unset OVSDB_SERVER_OPTS
34 unset OVS_VSWITCHD_OPTS
35 unset CORE_LIMIT
36 unset ENABLE_MONITOR
37 default=/etc/default/openvswitch-switch
38 if [ -f $default ] ; then
39 . $default
40 fi
41
42 : ${ENABLE_MONITOR:=y}
43
44 set -e
45
46 # running_pid pid name
47 #
48 # Check if 'pid' is a process named 'name'
49 running_pid()
50 {
51 local pid=$1 name=$2
52 [ -z "$pid" ] && return 1
53 [ ! -d /proc/$pid ] && return 1
54 cmd=`cat /proc/$pid/cmdline | tr "\000" "\n"|head -n 1 |cut -d : -f 1`
55 # Is this the expected child?
56 case $cmd in
57 $name|*/$name)
58 return 0
59 ;;
60 *)
61 return 1
62 ;;
63 esac
64 }
65
66 # running name
67 #
68 # Checks for a running process named 'name' by looking for a pidfile
69 # named /var/run/openvswitch/${name}.pid
70 running()
71 {
72 local name=$1
73 local pidfile=/var/run/openvswitch/${name}.pid
74
75 # No pidfile, probably no daemon present
76 [ ! -f "$pidfile" ] && return 1
77
78 # Obtain the pid and check it against the binary name
79 pid=`cat $pidfile`
80 running_pid $pid $name || return 1
81 return 0
82 }
83
84 # force_stop name
85 #
86 # Checks for a running process named 'name', by looking for a pidfile
87 # named /var/run/openvswitch/${name}.pid, and then kills it and waits
88 # for it to die.
89 force_stop() {
90 local name=$1
91 local pidfile=/var/run/openvswitch/${name}.pid
92
93 [ ! -f "$pidfile" ] && return
94 if running $name; then
95 kill $pid
96 [ -n "$DODTIME" ] && sleep "$DODTIME"s
97 if running $name; then
98 kill -KILL $pid
99 [ -n "$DODTIME" ] && sleep "$DODTIME"s
100 if running $name; then
101 echo "Cannot kill $name (pid=$pid)!"
102 exit 1
103 fi
104 fi
105 fi
106 rm -f $pidfile
107 return 0
108 }
109
110 must_succeed() {
111 echo -n "$1: "
112 shift
113 if "$@"; then
114 echo "success."
115 else
116 echo " ERROR."
117 exit 1
118 fi
119 }
120
121 check_op() {
122 echo -n "$1: "
123 shift
124 if "$@"; then
125 echo "success."
126 else
127 echo " ERROR."
128 fi
129 }
130
131 # is_module_loaded module
132 #
133 # Returns 0 if 'module' is loaded, 1 otherwise.
134
135 is_module_loaded() {
136 local module=$1
137 grep -q "^$module " /proc/modules
138 }
139
140 # load_module module
141 #
142 # Loads 'module' into the running kernel, if it is not already loaded.
143 load_module() {
144 local module=$1
145 echo -n "Loading $module: "
146 if is_module_loaded $module; then
147 echo "already loaded, nothing to do."
148 elif modprobe $module; then
149 echo "success."
150 else
151 echo "ERROR."
152 echo "$module has probably not been built for this kernel."
153 if ! test -d /usr/share/doc/openvswitch-datapath-source; then
154 echo "Install the openvswitch-datapath-source package, then read"
155 echo "/usr/share/doc/openvswitch-datapath-source/README.Debian"
156 else
157 echo "For instructions, read"
158 echo "/usr/share/doc/openvswitch-datapath-source/README.Debian"
159 fi
160 exit 1
161 fi
162 }
163
164 # unload_module module
165 #
166 # Unloads 'module' from the running kernel, if it is loaded.
167 unload_module() {
168 local module=$1
169 echo -n "Unloading $module: "
170 if is_module_loaded $module; then
171 if rmmod $module; then
172 echo "success."
173 else
174 echo "ERROR."
175 exit 1
176 fi
177 else
178 echo "not loaded, nothing to do."
179 fi
180 }
181
182 unload_modules() {
183 if is_module_loaded openvswitch_mod; then
184 for dp in $(ovs-dpctl dump-dps); do
185 echo -n "Deleting datapath $dp: "
186 if ovs-dpctl del-dp $dp; then
187 echo "success."
188 else
189 echo "ERROR."
190 fi
191 done
192 fi
193 unload_module openvswitch_mod
194 }
195
196 case "$1" in
197 start)
198 load_module openvswitch_mod
199
200 if test -n "$CORE_LIMIT"; then
201 check_op "Setting core limit to $CORE_LIMIT" ulimit -c "$CORE_LIMIT"
202 fi
203
204 # Create an empty configuration database if it doesn't exist.
205 if test ! -e /etc/openvswitch/conf.db; then
206 install -d -m 755 -o root -g root /etc/openvswitch
207
208 # Create configuration database.
209 ovsdb-tool -vANY:console:emer \
210 create /etc/openvswitch/conf.db \
211 /usr/share/openvswitch/vswitch.ovsschema
212 else
213 # Upgrade or downgrade schema and compact database.
214 ovsdb-tool -vANY:console:emer \
215 convert /etc/openvswitch/conf.db \
216 /usr/share/openvswitch/vswitch.ovsschema
217 fi
218
219 if test "$ENABLE_MONITOR" = y; then
220 monitor_opt=--monitor
221 else
222 monitor_opt=
223 fi
224
225 if [ ! -d /var/run/openvswitch ]; then
226 install -d -m 755 -o root -g root /var/run/openvswitch
227 fi
228
229 if [ ! -d /var/log/openvswitch ]; then
230 install -d -m 755 -o root -g root /var/log/openvswitch
231 fi
232
233 # Start ovsdb-server.
234 set --
235 set -- "$@" /etc/openvswitch/conf.db
236 set -- "$@" --verbose=ANY:console:emer --verbose=ANY:syslog:err
237 set -- "$@" --log-file=/var/log/openvswitch/ovsdb-server.log
238 set -- "$@" --detach --pidfile $monitor_opt
239 set -- "$@" --remote punix:/var/run/openvswitch/db.sock
240 set -- "$@" --remote db:Open_vSwitch,managers
241 set -- "$@" --private-key=db:SSL,private_key
242 set -- "$@" --certificate=db:SSL,certificate
243 set -- "$@" --bootstrap-ca-cert=db:SSL,ca_cert
244 set -- "$@" $OVSDB_SERVER_OPTS
245 echo -n "Starting ovsdb-server: "
246 start-stop-daemon --start --quiet \
247 --pidfile /var/run/openvswitch/ovsdb-server.pid \
248 --exec $ovsdb_server -- "$@"
249 if running ovsdb-server; then
250 echo "ovsdb-server."
251 else
252 echo " ERROR."
253 fi
254
255 ovs-vsctl --no-wait init
256
257 # Start ovs-vswitchd.
258 set --
259 set -- "$@" --verbose=ANY:console:emer --verbose=ANY:syslog:err
260 set -- "$@" --log-file=/var/log/openvswitch/ovs-vswitchd.log
261 set -- "$@" --detach --pidfile $monitor_opt
262 set -- "$@" unix:/var/run/openvswitch/db.sock
263 set -- "$@" $OVS_VSWITCHD_OPTS
264 echo -n "Starting ovs-vswitchd: "
265 start-stop-daemon --start --quiet \
266 --pidfile /var/run/openvswitch/ovs-vswitchd.pid \
267 --exec $ovs_vswitchd -- "$@"
268 if running ovs-vswitchd; then
269 echo "ovs-vswitchd."
270 else
271 echo " ERROR."
272 fi
273 ;;
274 stop)
275 echo -n "Stopping ovs-vswitchd: "
276 start-stop-daemon --stop --quiet --oknodo --retry 5 \
277 --pidfile /var/run/openvswitch/ovs-vswitchd.pid \
278 --exec $ovs_vswitchd
279 echo "ovs-vswitchd."
280
281 echo -n "Stopping ovsdb-server: "
282 start-stop-daemon --stop --quiet --oknodo --retry 5 \
283 --pidfile /var/run/openvswitch/ovsdb-server.pid \
284 --exec $ovsdb_server
285 echo "ovsdb-server."
286 ;;
287 force-stop)
288 echo -n "Forcefully stopping ovs-vswitchd: "
289 force_stop ovs-vswitchd
290 if ! running ovs-vswitchd; then
291 echo "ovs-vswitchd."
292 else
293 echo " ERROR."
294 fi
295
296 echo -n "Forcefully stopping ovsdb-server: "
297 force_stop ovsdb-server
298 if ! running ovsdb-server; then
299 echo "ovsdb-server."
300 else
301 echo " ERROR."
302 fi
303 ;;
304 unload)
305 unload_modules
306 ;;
307 reload)
308 ;;
309 force-reload)
310 # Nothing to do, since ovs-vswitchd automatically reloads
311 # whenever its configuration changes, and ovsdb-server doesn't
312 # have anything to reload.
313 ;;
314 restart)
315 $0 stop || true
316 $0 start
317 ;;
318 status)
319 for daemon in ovs-vswitchd ovsdb-server; do
320 echo -n "$daemon is "
321 if running $daemon; then
322 echo "running"
323 else
324 echo " not running."
325 exit 1
326 fi
327 done
328 ;;
329 *)
330 N=/etc/init.d/openvswitch-switch
331 echo "Usage: $N {start|stop|restart|force-reload|status|force-stop|unload}" >&2
332 exit 1
333 ;;
334 esac
335
336 exit 0